var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input } from '@angular/core';
import { DataTableComponent } from './data-table.component';
import { DataTableHeadTmplComponent } from './tmpl/data-table-head-tmpl.component';
import { DataTableTmplsComponent } from './tmpl/data-table-tmpls.component';
var DataTableHeadComponent = (function () {
    function DataTableHeadComponent(dt) {
        this.dt = dt;
        this.searchQuery = {};
    }
    DataTableHeadComponent.prototype.onHeadClick = function (column) {
        if (!column.sortable) {
            return;
        }
        if (this.sortField === column.field) {
            this.sortDirection = this.sortDirection === 'ASC' ? 'DESC' : 'ASC';
        }
        else {
            this.sortField = column.field;
            this.sortDirection = 'ASC';
        }
        this.dt.sortChange.emit({ field: this.sortField, direction: this.sortDirection, column: column });
    };
    DataTableHeadComponent.prototype.hasAnyFilterColumns = function (columns) {
        return (columns || []).some(function (col) { return col.filterable; });
    };
    DataTableHeadComponent.prototype.onCheckAllChange = function () {
        this.dt.onCheckAllChange(this.allChecked);
    };
    DataTableHeadComponent.prototype.onSearchQueryChange = function () {
        this.dt.onSearchQueryChange(this.searchQuery);
    };
    DataTableHeadComponent.prototype.canFilterable = function (column) {
        return column.field && column.field !== '$index' && column.filterable;
    };
    return DataTableHeadComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableHeadComponent.prototype, "checkable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableHeadComponent.prototype, "allChecked", void 0);
__decorate([
    Input(),
    __metadata("design:type", DataTableHeadTmplComponent)
], DataTableHeadComponent.prototype, "headTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], DataTableHeadComponent.prototype, "columns", void 0);
__decorate([
    Input(),
    __metadata("design:type", DataTableTmplsComponent)
], DataTableHeadComponent.prototype, "dataTableTemplates", void 0);
DataTableHeadComponent = __decorate([
    Component({
        selector: 're-data-table-head,[reDataTableHead]',
        template: "\n    <ng-container>\n      <template [ngTemplateOutlet]=\"headTemplate ? headTemplate.template : dataTableTemplates.headTemplate\"\n                [ngOutletContext]=\"{ $implicit: this }\">\n      </template>\n\n      <!--filter row-->\n      <tr *ngIf=\"hasAnyFilterColumns(columns)\">\n        <th *ngIf=\"checkable\"></th>\n        <th *ngFor=\"let column of columns\">\n          <ng-container *ngIf=\"canFilterable(column)\">\n            <template [ngTemplateOutlet]=\"dataTableTemplates.getCellFilterTemplate(column)\"\n                      [ngOutletContext]=\"{ $implicit: this , column: column}\">\n            </template>\n          </ng-container>\n        </th>\n      </tr>\n    </ng-container>\n  ",
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [DataTableComponent])
], DataTableHeadComponent);
export { DataTableHeadComponent };
//# sourceMappingURL=data-table-head.component.js.map