var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ViewChild, TemplateRef } from '@angular/core';
import { DataTableCellTmplComponent } from './data-table-cell-tmpl.component';
import { stopPropagationIfExist } from '../../utils/dom-utils';
var DataTableTmplsComponent = (function () {
    function DataTableTmplsComponent() {
    }
    DataTableTmplsComponent.prototype.getTemplate = function (fieldType) {
        return this[fieldType || 'text'] || this.text;
    };
    DataTableTmplsComponent.prototype.getCellViewTemplate = function (column) {
        if (column.cellCmp) {
            return column.cellCmp.template;
        }
        var template = this.getTemplate(column.fieldType);
        return template.view ? template.view.template : this.text.view.template;
    };
    DataTableTmplsComponent.prototype.getCellEditTemplate = function (column) {
        if (column.cellEditCmp) {
            return column.cellEditCmp.template;
        }
        var template = this.getTemplate(column.fieldType);
        return template.edit ? template.edit.template : this.text.edit.template;
    };
    DataTableTmplsComponent.prototype.getCellFilterTemplate = function (column) {
        if (column.cellFilterCmp) {
            return column.cellFilterCmp.template;
        }
        var template = this.getTemplate(column.fieldType);
        return template.filter ? template.filter.template : this.text.filter.template;
    };
    DataTableTmplsComponent.prototype.stopPropagation = function ($event) {
        stopPropagationIfExist($event);
    };
    return DataTableTmplsComponent;
}());
__decorate([
    ViewChild('defaultHeadTemplate'),
    __metadata("design:type", TemplateRef)
], DataTableTmplsComponent.prototype, "headTemplate", void 0);
__decorate([
    ViewChild('defaultPagerTemplate'),
    __metadata("design:type", TemplateRef)
], DataTableTmplsComponent.prototype, "pagerTemplate", void 0);
__decorate([
    ViewChild('textCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "text", void 0);
__decorate([
    ViewChild('numberCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "number", void 0);
__decorate([
    ViewChild('telCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "tel", void 0);
__decorate([
    ViewChild('mailCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "mail", void 0);
__decorate([
    ViewChild('imageCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "image", void 0);
__decorate([
    ViewChild('dateCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "date", void 0);
__decorate([
    ViewChild('datetimeCellTemplate'),
    __metadata("design:type", DataTableCellTmplComponent)
], DataTableTmplsComponent.prototype, "datetime", void 0);
DataTableTmplsComponent = __decorate([
    Component({
        selector: 're-data-table-templates',
        template: "\n    <!-- begin:template: header label template-->\n    <template #defaultHeadTemplate let-head=\"\">\n      <tr>\n        <th *ngIf=\"head.checkable\" class=\"checkable-cell\">\n          <form class=\"form-inline\">\n            <div class=\"form-group\">\n              <div class=\"checkbox\">\n                <label>\n                  <input type=\"checkbox\" name=\"checkAll\" [(ngModel)]=\"head.allChecked\" (change)=\"head.onCheckAllChange()\">\n                </label>\n              </div>\n            </div>\n          </form>\n        </th>\n        <th *ngFor=\"let column of head.columns\" (click)=\"head.onHeadClick(column)\" [style.width]=\"column.width || ''\">\n          {{column.header}} <i *ngIf=\"head.sortField == column.field\" class=\"glyphicon\"\n                               [ngClass]=\"{ 'glyphicon-triangle-bottom': head.sortDirection == 'DESC','glyphicon-triangle-top': head.sortDirection == 'ASC' }\"></i>\n        </th>\n      </tr>\n    </template>\n    <!--end:tempate-->\n\n    <!-- begin:template: pager template-->\n    <template #defaultPagerTemplate let-pager=\"pager\" let-pagerPanel=\"\">\n      <re-pagination cssClass=\"table-pagination\" [total]=\"pager.total\" [pageSize]=\"pager.pageSize\"\n                     [maxItems]=\"pager.maxItems || pagerPanel.pagerMaxItems\" [(pageIndex)]=\"pager.pageIndex\"\n                     (pageIndexChange)=\"pagerPanel.onPageChange($event)\">\n      </re-pagination>\n    </template>\n    <!--end:tempate-->\n\n    <!-- begin:template: cell view, edit, filter template-->\n    <re-cell-template #textCellTemplate type=\"text\">\n      <re-cell>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cellItem=\"cellItem\" let-cellValue=\"cellValue\">\n          {{cellValue}}\n        </template>\n      </re-cell>\n\n      <re-cell-edit>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\" let-cell=\"\">\n          <form class=\"form-inline\">\n            <div class=\"form-group\">\n              <input [type]=\"column.fieldType\" class=\"form-control\" [reAutoFocus]=\"cell.isCellEdit\"\n                     [name]=\"column.field\" [(ngModel)]=\"rowItem[column.field]\"\n                     (keydown.enter)=\"cell.onFinishCellEdit($event)\"\n                     (blur)=\"cell.onFinishCellEdit($event)\"/>\n            </div>\n          </form>\n        </template>\n      </re-cell-edit>\n\n      <re-cell-filter>\n        <template let-head=\"\" let-column=\"column\">\n          <input [type]=\"column.fieldType\" class=\"form-control search\" [(ngModel)]=\"head.searchQuery[column.field]\"\n                 [name]=\"column.field\" (keydown.enter)=\"head.onSearchQueryChange()\" (change)=\"head.onSearchQueryChange()\"/>\n        </template>\n      </re-cell-filter>\n\n    </re-cell-template>\n\n    <re-cell-template #numberCellTemplate type=\"number\">\n      <re-cell-filter>\n        <template let-head=\"\" let-column=\"column\">\n          <form>\n            <div class=\"row\">\n              <div class=\"col-xs-12 col-sm-6\">\n                <input type=\"number\" class=\"form-control search\" placeholder=\"From\"\n                       [(ngModel)]=\"head.searchQuery['ge$' + column.field]\"\n                       [name]=\"column.field + '_min'\" (keydown.enter)=\"head.onSearchQueryChange()\"\n                       (change)=\"head.onSearchQueryChange()\"/>\n              </div>\n              <div class=\"col-xs-12 col-sm-6\">\n                <input type=\"number\" class=\"form-control search\" placeholder=\"To\"\n                       [(ngModel)]=\"head.searchQuery['le$' +column.field]\"\n                       [name]=\"column.field +'_max'\" (keydown.enter)=\"head.onSearchQueryChange()\"\n                       (change)=\"head.onSearchQueryChange()\"/>\n              </div>\n            </div>\n          </form>\n        </template>\n      </re-cell-filter>\n\n    </re-cell-template>\n\n    <re-cell-template #telCellTemplate type=\"tel\">\n      <re-cell>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cellItem=\"cellItem\" let-cellValue=\"cellValue\">\n          <a [href]=\"'tel:' + cellValue\" (click)=\"stopPropagation($event)\">{{cellValue}}</a>\n        </template>\n      </re-cell>\n\n    </re-cell-template>\n\n    <re-cell-template #mailCellTemplate type=\"mail\">\n      <re-cell>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cellItem=\"cellItem\" let-cellValue=\"cellValue\">\n          <a [href]=\" cellValue ? ('mailto:' + cellValue) : ''\" (click)=\"stopPropagation($event)\">{{cellValue}}</a>\n        </template>\n      </re-cell>\n\n    </re-cell-template>\n\n    <re-cell-template #imageCellTemplate type=\"image\">\n      <re-cell>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cellItem=\"cellItem\" let-cellValue=\"cellValue\">\n          <img class=\"img-responsive\" [src]=\"cellValue\" [attr.alt]=\"cellValue\">\n        </template>\n      </re-cell>\n\n      <re-cell-edit>\n        <template>\n          <strong>You need customise edit template!</strong>\n        </template>\n      </re-cell-edit>\n\n      <re-cell-filter>\n\n      </re-cell-filter>\n\n    </re-cell-template>\n\n    <re-cell-template #dateCellTemplate type=\"date\">\n      <re-cell-edit>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cell=\"\">\n          <form class=\"form-inline\">\n            <div class=\"form-group\">\n              <div class=\"input-group\">\n                <input class=\"form-control search\" [reAutoFocus]=\"cell.isCellEdit\"\n                       [name]=\"column.field\" [(ngModel)]=\"rowItem[column.field]\" reDatePicker\n                       [dateFormat]=\"column.extraOptions?.dateFormat\" #datePicker=\"datePicker\" [appendBody]=\"true\"\n                       (ngModelChange)=\"cell.onFinishCellEdit()\">\n                <div class=\"input-group-addon\" (click)=\"datePicker.toggle($event)\">\n                  <i class=\"glyphicon glyphicon-calendar\"></i>\n                </div>\n              </div>\n            </div>\n          </form>\n        </template>\n      </re-cell-edit>\n\n      <!--<re-cell-filter>-->\n      <!--<template let-head=\"\" let-column=\"column\">-->\n      <!--<form>-->\n      <!--<div class=\"row\">-->\n      <!--<div class=\"col-xs-12 col-sm-6\">-->\n      <!--<div class=\"input-group\">-->\n      <!--<input class=\"form-control search\" [name]=\"'ge$' + column.field\" placeholder=\"From\"-->\n      <!--[(ngModel)]=\"head.searchQuery['ge$' + column.field]\"-->\n      <!--reDatePicker #geDatePicker=\"datePicker\" (ngModelChange)=\"head.onSearchQueryChange()\">-->\n      <!--<div class=\"input-group-addon\" (click)=\"geDatePicker.toggle($event)\">-->\n      <!--<i class=\"glyphicon glyphicon-calendar\"></i>-->\n      <!--</div>-->\n      <!--</div>-->\n      <!--</div>-->\n      <!--<div class=\"col-xs-12 col-sm-6\">-->\n      <!--<div class=\"input-group\">-->\n      <!--<input class=\"form-control search\" [name]=\"'le' + column.field\" placeholder=\"To\"-->\n      <!--[(ngModel)]=\"head.searchQuery['le$' + column.field]\"-->\n      <!--reDatePicker #leDatePicker=\"datePicker\" (ngModelChange)=\"head.onSearchQueryChange()\">-->\n      <!--<div class=\"input-group-addon\" (click)=\"leDatePicker.toggle($event)\">-->\n      <!--<i class=\"glyphicon glyphicon-calendar\"></i>-->\n      <!--</div>-->\n      <!--</div>-->\n      <!--</div>-->\n      <!--</div>-->\n      <!--</form>-->\n      <!--</template>-->\n      <!--&lt;!&ndash;</re-cell-filter>&ndash;&gt;-->\n\n    </re-cell-template>\n\n    <re-cell-template #datetimeCellTemplate type=\"datetime\">\n      <re-cell-edit>\n        <template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\"\n                  let-cell=\"\">\n          <form class=\"form-inline\">\n            <div class=\"form-group\">\n              <div class=\"input-group\">\n                <input class=\"form-control search\" [reAutoFocus]=\"cell.isCellEdit\" [showTimePicker]=\"true\"\n                       [name]=\"column.field\" [(ngModel)]=\"rowItem[column.field]\" reDatePicker [appendBody]=\"true\"\n                       [dateFormat]=\"column.extraOptions?.dateFormat\" #datePicker=\"datePicker\"\n                       (ngModelChange)=\"cell.onFinishCellEdit()\">\n                <div class=\"input-group-addon\" (click)=\"datePicker.toggle($event)\">\n                  <i class=\"glyphicon glyphicon-calendar\"></i>\n                </div>\n              </div>\n            </div>\n          </form>\n        </template>\n      </re-cell-edit>\n    </re-cell-template>\n    <!--<re-cell-template #selectCellTemplate type=\"select\">-->\n    <!--<re-cell-edit>-->\n    <!--<template let-rowIndex=\"rowIndex\" let-colIndex=\"colIndex\" let-rowItem=\"rowItem\" let-column=\"column\" let-cell=\"\">-->\n    <!--<form>-->\n    <!--<div class=\"form-group\">-->\n    <!--<select class=\"form-control\" autofocus=\"autofocus\" [name]=\"column.field\"-->\n    <!--[(ngModel)]=\"rowItem[column.field]\" (ngModelChange)=\"cell.onFinishCellEdit()\">-->\n    <!--<option *ngFor=\"let item of column.extraOptions\" [value]=\"item.value || item\">{{item.label || item}}-->\n    <!--</option>-->\n    <!--</select>-->\n    <!--</div>-->\n    <!--</form>-->\n    <!--</template>-->\n    <!--</re-cell-edit>-->\n\n    <!--<re-cell-filter>-->\n    <!--<template let-head=\"\" let-column=\"column\">-->\n    <!--<form>-->\n    <!--<div class=\"form-group\">-->\n    <!--<select class=\"form-control search\" [name]=\"column.field\"-->\n    <!--[(ngModel)]=\"head.searchQuery[column.field]\" (ngModelChange)=\"head.onSearchQueryChange()\">-->\n    <!--<option *ngFor=\"let item of column?.extraOptions\" [value]=\"item.value || item\">{{item.label || item}}-->\n    <!--</option>-->\n    <!--</select>-->\n    <!--</div>-->\n    <!--</form>-->\n    <!--</template>-->\n    <!--</re-cell-filter>-->\n\n    <!--</re-cell-template>-->\n    <!--end:tempate-->\n  ",
        changeDetection: ChangeDetectionStrategy.OnPush
    })
], DataTableTmplsComponent);
export { DataTableTmplsComponent };
//# sourceMappingURL=data-table-tmpls.component.js.map