var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy } from '@angular/core';
import { ModalDismissReasons } from '../modal';
import { RebirthUIConfig } from '../rebirth-ui.config';
var ConfirmDialogComponent = (function () {
    function ConfirmDialogComponent(rebirthUIConfig) {
        this.rebirthUIConfig = rebirthUIConfig;
        this.btnYes = rebirthUIConfig.dialog.button.yes;
        this.btnNo = rebirthUIConfig.dialog.button.no;
    }
    ConfirmDialogComponent.prototype.yes = function () {
        this.dismiss.emit(ModalDismissReasons.YES);
    };
    ConfirmDialogComponent.prototype.no = function () {
        this.dismiss.error(ModalDismissReasons.NO);
    };
    return ConfirmDialogComponent;
}());
ConfirmDialogComponent = __decorate([
    Component({
        selector: 're-confirm-dialog',
        template: "\n    <div class=\"modal-header\">\n      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"no()\">\n        <span aria-hidden=\"true\">&times;</span></button>\n      <h4 class=\"modal-title\">{{context.title}}</h4>\n    </div>\n    <div class=\"modal-body\">\n      <p *ngIf=\"!context.html\">{{context.content}}</p>\n      <p *ngIf=\"context.html\" [innerHTML]=\"context.content\"></p>\n    </div>\n    <div class=\"modal-footer\">\n      <button type=\"button\" class=\"btn btn-primary\" (click)=\"yes()\">{{context.yes || btnYes}}</button>\n      <button type=\"button\" class=\"btn btn-warning\" (click)=\"no()\">{{context.no || btnNo}}</button>\n    </div>\n  ",
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [RebirthUIConfig])
], ConfirmDialogComponent);
export { ConfirmDialogComponent };
//# sourceMappingURL=confirm-dialog.component.js.map